<template>

    <!-- <ConfirmationDialog ref="deleteConfirmation" title="Delete Platform" message="Are you sure you want to delete this platform?" :verificationString="pendingDeletePlatform.name"  @confirm="deletePlatform()" /> -->

    <v-card>
        <v-card-title class="text-h5">
            Users
        </v-card-title>

        <v-container v-if="pendingUsers.length > 0" class="flex-d">
            <v-card-subtitle class="text-h6">
                Pending Users
            </v-card-subtitle>

            <v-row>
                <v-col cols="6">

                    <v-table
                    hide-default-header
                    hide-default-footer>
                        <thead >
                            <tr>
                                <th>Username</th>
                                <th>Email</th>
                                <th>Approve</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="user in pendingUsers" v-bind:key="user.username">
                                <td class="text-left"> {{ user.username }}</td>
                                <td class="text-left"> {{ user.email }}</td>
                                <td class="text-left"> <v-btn color="primary" @click="updateUserRole(user, 'reporter')">Approve</v-btn></td>
                            </tr>
                        </tbody>
                    </v-table>
                </v-col>

            </v-row>

        </v-container>

        <v-container>
            <v-card-subtitle class="text-h6">
                Active Users
            </v-card-subtitle>
          
            <VDataTable 
                v-model:expanded="expanded"
                :headers="headers" 
                :items="activeUsers" 
                :items-per-page="25"
                :editabled="true"
                item-value="username" 
                hide-default-footer

                align="left"
                row-class="hightlight-row"
                >

                <template v-slot:item.actions="{ item }">
                    <v-icon color="red" @click.stop="verifyDelete(item.raw)">mdi-delete</v-icon>
                </template>

                <template  v-slot:item.role="{item}">
                    <td>

                        <v-select
                            v-model="item.raw.role"
                            :items="config.roles"
                            item-title="name"
                            item-value="name"
                            variant="underlined"
                            @update:modelValue="updateUserRole(item.raw, item.raw.role)"
                            :disabled="item.raw._id === authUser._id"

                        >

                    </v-select>
                    </td>


                </template>

<!-- 
                <template v-if="items.length < 8" v-slot:bottom>
                    <v-row>

                    </v-row>    
                </template> -->
            </VDataTable>

            </v-container>
        <v-container class=" d-flex justify-end">

               
        </v-container>
        

    </v-card>
</template>
<style>

.highlight-row:hover {
  background-color: #3b6e3d;
  cursor: pointer;
}

</style>
<script>
import { ref, onMounted, computed, reactive, watch } from "vue";
import { useUserStore } from "@/store/users";
import { useAuthStore } from "@/store/auth";
import { VDataTable } from "vuetify/labs/VDataTable";
import { useRouter } from 'vue-router'
import ConfirmationDialog from "../ConfirmationDialog.vue";



export default {
    props:{ },
    setup(props ) {
        const store = useUserStore();
        const authStore = useAuthStore();

        const expanded = ref([]);

        const router= useRouter();


        const config = computed(() => {
            return authStore.config;
        });

        const activeUsers = computed(() => {
            return store.users.filter((user) => user.role !== 'pending');
        });

        const pendingUsers = computed(() => {
            return store.users.filter((user) => user.role === 'pending');
        });

        const items = computed(() => { return store.users });

        const deleteConfirmation = ref(null);
        const pendingUserDelete = reactive({
            _id: 0,
            username: null
        })

        onMounted(() => {
            store.fetchUsers();
            authStore.fetchConfig();
        });

 
        const headers = ref([
            { align: 'left' , title: 'Username', key: 'username', sortable: false },
            { title: 'Email', key: 'email', sortable: false },
            { title: 'Role', key: 'role', sortable: false, width:"10%"},
            { title: 'Actions', key: 'actions', sortable: false },
        ]);


        function onRowClick(e, { item }){

            //router.push({ name: 'platforms', params: { platformId: item.value } });
           //router.push('/platforms/' + item.value);

        }



        function verifyDelete(user) {
            
        }

        function deleteUser () 
        {

        }

        async function updateUserRole(user, role) {
            await store.updateUser(user, {role: role} );
            await store.fetchUsers();
        }

        async function add()
        {
            console.log('add');
        }


        return {
            items,
            activeUsers,
            pendingUsers,
            updateUserRole,
            deleteUser,
            headers,
            expanded,
            onRowClick,
            verifyDelete,
            deleteConfirmation,
            pendingUserDelete,
            authUser: authStore.authUser,
            config,
            add
            
        }
    },
    components: {
    VDataTable,
    ConfirmationDialog
}
}


</script>
